## flameshot 11.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
# cmake_policy(SET CMP0076 OLD)

set(FLAMESHOT_VERSION 11.0.0)

# Flameshot-org
set(GIT_API_URL "https://api.github.com/repos/flameshot-org/flameshot/releases/latest")
# Namecheap
# set(GIT_API_URL "https://api.github.com/repos/namecheap/flameshot/releases/latest")

# TODO - fix it for all linux distros
#find_package (Git)
#if (GIT_FOUND)
#  message("git found: ${GIT_EXECUTABLE} in version     ${GIT_VERSION_STRING}")
#
#  # set flameshot updates url
#  execute_process(COMMAND ${GIT_EXECUTABLE} ls-remote --get-url OUTPUT_VARIABLE GIT_ORIGIN_REMOTE)
#  message("GIT_ORIGIN_REMOTE: ${GIT_ORIGIN_REMOTE}")
#  string(REGEX REPLACE ".git\r*\n*$" "/releases/latest" GIT_API_URL ${GIT_ORIGIN_REMOTE})
#  string(REGEX REPLACE "^.*:" "https://api.github.com/repos/" GIT_API_URL ${GIT_API_URL})
#  message("GIT_API_URL: '${GIT_API_URL}'")
#
#  # get application version
#  execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=0 --match v[0-9]* OUTPUT_VARIABLE FLAMESHOT_VERSION)
#  string(REGEX REPLACE "\r" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  string(REGEX REPLACE "\n" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  string(REGEX REPLACE "^v" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  message("FLAMESHOT_VERSION: '${FLAMESHOT_VERSION}'")
#else()
#  message("git command is not found")
#endif ()

project(
        flameshot
        VERSION ${FLAMESHOT_VERSION}
        LANGUAGES CXX)
set(PROJECT_NAME_CAPITALIZED "Flameshot")

# This can be read from ${PROJECT_NAME} after project() is called
if (APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")
endif()


# Configuration options
set(DEFAULT_RUN_IN_PLACE FALSE)
if(WIN32)
  set(DEFAULT_RUN_IN_PLACE TRUE)
  # For Windows RC file.
  add_definitions(-DFLAMESHOT_VERSION_MAJOR=${CMAKE_PROJECT_VERSION_MAJOR})
  add_definitions(-DFLAMESHOT_VERSION_MINOR=${CMAKE_PROJECT_VERSION_MINOR})
  add_definitions(-DFLAMESHOT_VERSION_BUGFIX=${CMAKE_PROJECT_VERSION_PATCH})
  add_definitions(-DFLAMESHOT_VERSION_BUILD=1)
  add_definitions(-DFLAMESHOT_VERSION_STRING="${PROJECT_VERSION}")
elseif(APPLE)
  set(Qt5_DIR "$(brew --prefix qt5)/lib/cmake/Qt5/" CACHE PATH "directory where Qt5Config.cmake exists.")
  set(CMAKE_MACOSX_BUNDLE ON)
  set(CMAKE_MACOSX_RPATH ON)
endif()
set(RUN_IN_PLACE
        ${DEFAULT_RUN_IN_PLACE}
        CACHE BOOL "Run directly in source directory structure")


option(FLAMESHOT_DEBUG_CAPTURE "Enable mode to make debugging easier" OFF)
option(USE_MONOCHROME_ICON "Build using monochrome icon as default" OFF)
option(GENERATE_TS "Regenerate translation source files" OFF)
option(USE_EXTERNAL_SINGLEAPPLICATION "Use external QtSingleApplication library" OFF)
option(USE_LAUNCHER_ABSOLUTE_PATH "Use absolute path for the desktop launcher" ON)

include(cmake/StandardProjectSettings.cmake)

add_library(project_options INTERFACE)
target_compile_features(project_options INTERFACE cxx_std_17)

add_library(project_warnings INTERFACE)

# enable cache system
include(cmake/Cache.cmake)

# standard compiler warnings
include(cmake/CompilerWarnings.cmake)
# set_project_warnings(project_warnings)

# sanitizer options if supported by compiler
include(cmake/Sanitizers.cmake)
enable_sanitizers(project_options)

# allow for static analysis options include(cmake/StaticAnalyzers.cmake)

set(QAPPLICATION_CLASS
        QApplication
        CACHE STRING "Inheritance class for SingleApplication")

if(USE_EXTERNAL_SINGLEAPPLICATION)
  # look for external QtSingleApplication
  # package dev-qt/qtsingleapplication provides no symlink to current version
  set(qtsingleapplication_libs libQt5Solutions_SingleApplication-2.6 Qt5Solutions_SingleApplication-2.6)
  find_library(QTSINGLEAPPLICATION_LIBRARY NAMES ${qtsingleapplication_libs})
  message(STATUS "Using external SingleApplication library")
else()
  add_subdirectory(external/singleapplication)
  set(QTSINGLEAPPLICATION_LIBRARY SingleApplication::SingleApplication)
endif()


option(BUILD_STATIC_LIBS ON)
option(BUILD_SHARED_LIBS OFF)
add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL) 

if (APPLE)
  add_subdirectory(external/QHotkey)
endif()
add_subdirectory(src)

# CPack
set(CPACK_PACKAGE_VENDOR "flameshot-org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Powerful yet simple to use screenshot software.")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_HOMEPAGE_URL "https://flameshot.org")
set(CPACK_PACKAGE_CONTACT "flameshot-org developers <info@flameshot.org>")
set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/data/img/app/org.flameshot.Flameshot.svg") # TODO: Can any generator make
# use of this?
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md") # TODO: Where is this used? Do we need a better
# source?

if(WIN32)
  # Include all dynamically linked runtime libraries such as MSVCRxxx.dll
  include(InstallRequiredSystemLibraries)

  if(RUN_IN_PLACE)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win64")
    else()
      set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win32")
    endif()

    set(CPACK_GENERATOR ZIP)

  else()
    set(CPACK_GENERATOR WIX ZIP)
    set(CPACK_PACKAGE_NAME "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_PACKAGE_EXECUTABLES ${PROJECT_NAME} "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_CREATE_DESKTOP_LINKS ${PROJECT_NAME})

    # WIX (Windows .msi installer)
    # 48x48 pixels
    set(CPACK_WIX_PRODUCT_ICON "${CMAKE_SOURCE_DIR}/data/img/app/flameshot.ico")
    # Supported languages can be found at http://wixtoolset.org/documentation/manual/v3/wixui/wixui_localization.html
    # set(CPACK_WIX_CULTURES "ar-SA,bg-BG,ca-ES,hr-HR,cs-CZ,da-DK,nl-NL,en-US,et-EE,fi-FI,fr-FR,de-DE")
    set(CPACK_WIX_UI_BANNER "${CMAKE_SOURCE_DIR}/packaging/win-installer/Bitmaps/CPACK_WIX_UI_BANNER.BMP")
    set(CPACK_WIX_UI_DIALOG "${CMAKE_SOURCE_DIR}/packaging/win-installer/Bitmaps/CPACK_WIX_UI_DIALOG.BMP")
    set(CPACK_WIX_PROPERTY_ARPHELPLINK "${CPACK_PACKAGE_HOMEPAGE_URL}")
    set(CPACK_WIX_PROPERTY_ARPURLINFOABOUT "${CPACK_PACKAGE_HOMEPAGE_URL}")
    set(CPACK_WIX_ROOT_FEATURE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}")
    set(CPACK_WIX_LIGHT_EXTRA_FLAGS "-dcl:high") # set high compression

    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/packaging/win-installer/LICENSE/GPL-3.0.txt")
    set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")

    # The correct way would be to include both x32 and x64 into one installer and install the appropriate one. CMake
    # does not support that, so there are two separate GUID's
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      set(CPACK_WIX_UPGRADE_GUID "26D8062A-66D9-48D9-8924-42090FB9B3F9")
    else()
      set(CPACK_WIX_UPGRADE_GUID "2C53E1B9-51D9-4429-AAE4-B02221959AA5")
    endif()
  endif()
elseif(APPLE)
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
  set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-osx")
  set(CPACK_GENERATOR ZIP)
else()
  set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-linux")
  set(CPACK_GENERATOR TGZ)
  set(CPACK_SOURCE_GENERATOR TGZ)
endif()

include(CPack)

=== src/CMakeLists.txt ===
find_package(
        Qt5
        CONFIG
        REQUIRED
        Core
        Gui
        Widgets
        Network
        Svg
        DBus
        LinguistTools)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# set application icon
if (APPLE)
    # generate iconset
    execute_process(
            COMMAND bash "-c" "mkdir -p flameshot.iconset"
    )
    execute_process(
            COMMAND bash "-c" "sips -z 16 16     \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_16x16.png"
            COMMAND bash "-c" "sips -z 32 32     \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_16x16@2x.png"
            COMMAND bash "-c" "sips -z 32 32     \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_32x32.png"
            COMMAND bash "-c" "sips -z 64 64     \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_32x32@2x.png"
            COMMAND bash "-c" "sips -z 64 64     \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_64x64x.png"
            COMMAND bash "-c" "sips -z 128 128   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome.png --out flameshot.iconset/icon_64x64@2.png"
            COMMAND bash "-c" "sips -z 128 128   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_128x128.png"
            COMMAND bash "-c" "sips -z 256 256   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_128x128@2x.png"
            COMMAND bash "-c" "sips -z 256 256   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_256x256.png"
            COMMAND bash "-c" "sips -z 512 512   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_256x256@2x.png"
            COMMAND bash "-c" "sips -z 512 512   \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_512x512.png"
            COMMAND bash "-c" "sips -z 1024 1024 \"${CMAKE_SOURCE_DIR}\"/data/img/app/flameshot.monochrome-1024.png --out flameshot.iconset/icon_512x512@2x.png"


            COMMAND bash "-c" "iconutil -c icns flameshot.iconset"
    )

    execute_process(
            COMMAND bash "-c" "rm -R flameshot.iconset"
    )

    execute_process(
            # copy icon from cache generated on the localhost if generation on CI failed
            COMMAND bash "-c" "[[ -r 'flameshot.icns' ]] || cp \"${CMAKE_SOURCE_DIR}\"/packaging/macos/flameshot.icns ./"
    )

    # Set application icon
    set(MACOSX_BUNDLE_ICON_FILE flameshot.icns)

    # And this part tells CMake where to find and install the file itself
    set(APP_ICON_MACOSX ${CMAKE_BINARY_DIR}/flameshot.icns)
    set_source_files_properties(${APP_ICON_MACOSX} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")

    add_executable(flameshot MACOSX_BUNDLE main.cpp ${APP_ICON_MACOSX})
else ()
    add_executable(flameshot)
endif ()

add_executable(Flameshot::flameshot ALIAS flameshot)

if (WIN32)
    set_property(TARGET flameshot PROPERTY WIN32_EXECUTABLE true)
    if (MSVC)
        target_compile_options(flameshot PRIVATE /source-charset:utf-8)
    endif ()
endif ()

add_subdirectory(cli)
add_subdirectory(config)
add_subdirectory(core)
add_subdirectory(utils)
add_subdirectory(widgets)
add_subdirectory(tools)




set(FLAMESHOT_TS_FILES
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ca.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_cs.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_de_DE.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_el.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_es.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_eu.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_fr.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_hu.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_it_IT.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ja.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ka.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ko.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nb_NO.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl_NL.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pl.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pt_BR.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ru.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sk.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sr_SP.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sv_SE.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_tr.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_uk.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_CN.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_HK.ts
        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_TW.ts)

if (GENERATE_TS)
    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${FLAMESHOT_TS_FILES})
else ()
    qt5_add_translation(QM_FILES ${FLAMESHOT_TS_FILES})
endif ()

target_sources(
        flameshot
        PRIVATE
        # ${CMAKE_CURRENT_SOURCE_DIR}/../external/Qt-Color-Widgets/src/QtColorWidgets/color_utils.cpp
        # ${CMAKE_CURRENT_SOURCE_DIR}/../external/Qt-Color-Widgets/src/QtColorWidgets/color_wheel.cpp
        # ${CMAKE_CURRENT_SOURCE_DIR}/../external/Qt-Color-Widgets/include/QtColorWidgets/color_wheel.hpp
        ${CMAKE_CURRENT_SOURCE_DIR}/../data/graphics.qrc
        ${CMAKE_CURRENT_SOURCE_DIR}/../data/flameshot.rc # windows binary icon resource file
        ${QM_FILES}
        main.cpp)

target_include_directories(
  flameshot
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../external/Qt-Color-Widgets/include>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dbus/>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/cli>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/config>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/core>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/arrow>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/pixelate>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/circle>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/circlecount>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/copy>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/exit>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/imgur>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/launcher>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/line>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/marker>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/move>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/pencil>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/pin>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/rectangle>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/redo>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/save>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/invert>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/selection>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/sizeindicator>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/text>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/undo>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/sizeincrease>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tools/sizedecrease>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/utils>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/widgets>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/widgets/panel>
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/widgets/capture>
         $<INSTALL_INTERFACE:include/mylib>)

if (USE_EXTERNAL_SINGLEAPPLICATION)
    add_compile_definitions(USE_EXTERNAL_SINGLEAPPLICATION=1)
else ()
    target_include_directories(
        flameshot
        PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../external/singleapplication>)
endif()

target_link_libraries(
        flameshot
        project_warnings
        project_options
        Qt5::Svg
        Qt5::DBus
        Qt5::Network
        Qt5::Widgets
        ${QTSINGLEAPPLICATION_LIBRARY}
        QtColorWidgets
)

if (APPLE)
    set(MACOSX_BUNDLE_IDENTIFIER "org.flameshot")
    set_target_properties(
            flameshot
            PROPERTIES
            XCODE_ATTRIBUTE_PRODUCT_BUNDLE_IDENTIFIER ${MACOSX_BUNDLE_IDENTIFIER}
    )
    target_link_libraries(
            flameshot
            qhotkey
    )
endif ()

if (WIN32)
    set(USE_OPENSSL FALSE)
    if (ENABLE_OPENSSL)
        find_package(OpenSSL)
        if (OPENSSL_FOUND)
            message(STATUS "OpenSSL support enabled.")
            set(USE_OPENSSL TRUE)
        endif ()
    else ()
        mark_as_advanced(CLEAR OPENSSL_LIBRARIES OPENSSL_INCLUDE_DIR)
    endif ()

    if (NOT USE_OPENSSL)
        message(WARNING "OpenSSL is required to upload screenshots")
    endif ()
endif ()

# Choose default color palette (small or large)
if($ENV{FLAMESHOT_PREDEFINED_COLOR_PALETTE_LARGE})
    set(FLAMESHOT_PREDEFINED_COLOR_PALETTE_LARGE true)
else()
    set(FLAMESHOT_PREDEFINED_COLOR_PALETTE_LARGE false)
endif()
message("Flameshot predefined color palette large: " ${FLAMESHOT_PREDEFINED_COLOR_PALETTE_LARGE})
target_compile_definitions(flameshot PRIVATE PREDEFINED_COLOR_PALETTE_LARGE=${FLAMESHOT_PREDEFINED_COLOR_PALETTE_LARGE})

find_package (Git)
if (GIT_FOUND)
    message("git found: ${GIT_EXECUTABLE} in version     ${GIT_VERSION_STRING}")
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD OUTPUT_VARIABLE FLAMESHOT_GIT_HASH)
    string(REGEX REPLACE "\r*\n$" "" FLAMESHOT_GIT_HASH "${FLAMESHOT_GIT_HASH}")
    target_compile_definitions(flameshot PRIVATE FLAMESHOT_GIT_HASH="${FLAMESHOT_GIT_HASH}")
    message("FLAMESHOT_GIT_HASH: ${FLAMESHOT_GIT_HASH}")
else()
    target_compile_definitions(flameshot PRIVATE FLAMESHOT_GIT_HASH="-")
    message("git command is not found")
endif ()
target_compile_definitions(flameshot PRIVATE APP_PREFIX="${CMAKE_INSTALL_PREFIX}")
target_compile_definitions(flameshot PRIVATE APP_VERSION="v${PROJECT_VERSION}")
target_compile_definitions(flameshot PRIVATE IMGUR_CLIENT_ID="313baf0c7b4d3ff")
#target_compile_definitions(flameshot PRIVATE QAPPLICATION_CLASS=QApplication)
target_compile_definitions(flameshot PRIVATE FLAMESHOT_APP_VERSION_URL="${GIT_API_URL}")
# Enable easier debugging of screenshot capture mode
if (FLAMESHOT_DEBUG_CAPTURE)
    target_compile_definitions(flameshot PRIVATE FLAMESHOT_DEBUG_CAPTURE)
endif ()

if (USE_MONOCHROME_ICON)
    target_compile_definitions(flameshot PRIVATE USE_MONOCHROME_ICON)
endif ()

foreach (FILE ${QM_FILES})
    get_filename_component(F_NAME ${FILE} NAME)
    add_custom_command(
            TARGET flameshot
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/${F_NAME}
            ${CMAKE_CURRENT_BINARY_DIR}/translations/${F_NAME})
endforeach ()

=== src/config/CMakeLists.txt ===
target_sources(
  flameshot
  PRIVATE buttonlistview.cpp
          clickablelabel.cpp
          configwindow.cpp
          configresolver.cpp
          configerrordetails.cpp
          extendedslider.cpp
          filenameeditor.cpp
          generalconf.cpp
          strftimechooserwidget.cpp
          styleoverride.cpp
          uicoloreditor.cpp
          visualseditor.cpp
          shortcutswidget.cpp
          setshortcutwidget.cpp
)

=== src/core/CMakeLists.txt ===
target_sources(flameshot PRIVATE
    controller.h
    flameshotdaemon.h
    flameshotdbusadapter.h
    qguiappcurrentscreen.h
)

target_sources(flameshot PRIVATE
    capturerequest.cpp
    controller.cpp
    flameshotdaemon.cpp
    flameshotdbusadapter.cpp
    qguiappcurrentscreen.cpp
)

IF (WIN32)
    target_sources(flameshot PRIVATE globalshortcutfilter.h globalshortcutfilter.cpp)
ENDIF ()

=== src/widgets/CMakeLists.txt ===
add_subdirectory(panel)
add_subdirectory(capture)

# Required to generate MOC
target_sources(
        flameshot
        PRIVATE capturelauncher.h
        draggablewidgetmaker.h
        imagelabel.h
        infowindow.h
        loadspinner.h
        notificationwidget.h
        orientablepushbutton.h
        historywidget.h
        updatenotificationwidget.h
        imguploaddialog.h
        capture/capturetoolobjects.h
)

target_sources(
        flameshot
        PRIVATE capturelauncher.cpp
        draggablewidgetmaker.cpp
        imagelabel.cpp
        infowindow.cpp
        loadspinner.cpp
        notificationwidget.cpp
        orientablepushbutton.cpp
        historywidget.cpp
        updatenotificationwidget.cpp
        imguploaddialog.cpp
        capture/capturetoolobjects.cpp
)

=== external/Qt-Color-Widgets/gallery/CMakeLists.txt ===
#
# Copyright (C) 2013-2020 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
set (QT_SUPPORTED_VERSIONS 5)


set(SCREENSHOT_SOURCES screenshot.cpp)
set(SCREENSHOT_BINARY screenshot_bin)

add_executable(${SCREENSHOT_BINARY} EXCLUDE_FROM_ALL ${SCREENSHOT_SOURCES})

target_link_libraries(
    ${SCREENSHOT_BINARY}
    PRIVATE
    ${COLOR_WIDGETS_LIBRARY}
    Qt${QT_VERSION_MAJOR}::Widgets
)

add_custom_target(gallery
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${SCREENSHOT_BINARY}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${SCREENSHOT_BINARY}
)

=== src/widgets/capture/CMakeLists.txt ===
# Required to generate MOC
target_sources(
        flameshot
        PRIVATE buttonhandler.h
        capturebutton.h
        capturetoolbutton.h
        capturewidget.h
        colorpicker.h
        hovereventfilter.h
        overlaymessage.h
        selectionwidget.h
        notifierbox.h
        modificationcommand.h)

target_sources(
        flameshot
        PRIVATE buttonhandler.cpp
        capturebutton.cpp
        capturetoolbutton.cpp
        capturewidget.cpp
        colorpicker.cpp
        hovereventfilter.cpp
        overlaymessage.cpp
        notifierbox.cpp
        selectionwidget.cpp
        modificationcommand.cpp)

=== external/Qt-Color-Widgets/src/QtColorWidgets/CMakeLists.txt ===
set (SOURCES
abstract_widget_list.cpp
bound_color_selector.cpp
color_2d_slider.cpp
color_delegate.cpp
color_dialog.cpp
color_dialog.ui
color_line_edit.cpp
color_list_widget.cpp
color_names.cpp
color_palette.cpp
color_palette_model.cpp
color_palette_widget.cpp
color_palette_widget.ui
color_preview.cpp
color_selector.cpp
color_utils.cpp
color_wheel.cpp
gradient_slider.cpp
hue_slider.cpp
swatch.cpp
gradient_editor.cpp
harmony_color_wheel.cpp
gradient_list_model.cpp
)

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

=== debian/changelog ===
flameshot (11.0.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake.

  [ Boyuan Yang ]
  * debian/patches/0003-Updated-weblate-translation.patch:
    Use updated translation from Weblate.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Jan 2022 21:57:02 -0500

flameshot (11.0.0-1) unstable; urgency=medium

  * New upstream stable release.
    + Refactor config handler.
      (Closes: #1003239, Closes: #1003224) (LP: #1957010)
  * Package grim is now recommended for installation. (Closes: #985201)
  * Package xdg-desktop-portal-* is not recommended for installation.
    (Closes: #996983)

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Jan 2022 21:27:30 -0500

flameshot (11.0~rc1+ds1-2) unstable; urgency=medium

  * debian/control: Recommend installation of package grim for
    screenshot support on Sway-based compositor. (upstream issue 2109)

 -- Boyuan Yang <byang@debian.org>  Fri, 31 Dec 2021 12:48:30 -0500

flameshot (11.0~rc1+ds1-1) unstable; urgency=medium

  * New upstream RC release.
  * debian/watch: Update monitoring patterns.
  * debian/control: Drop useless build-dependency libspdlog-dev.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Wed, 29 Dec 2021 13:27:50 -0500

flameshot (0.10.2+ds1-4) unstable; urgency=medium

  * Rebuild the package.
  * debian/control: Tighten build dependency to libspdlog-dev (>= 1:1.9~)
    to assist libfmt8 transition. (Closes: #1002129)

 -- Boyuan Yang <byang@debian.org>  Tue, 21 Dec 2021 13:19:19 -0500

flameshot (0.10.2+ds1-3) unstable; urgency=medium

  * debian/patches: Add patch to always use native wayland backend on KDE
    plasma.

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Nov 2021 13:18:30 -0500

flameshot (0.10.2+ds1-2) unstable; urgency=medium

  * debian/control: Recommend xdg-desktop-portal-* installation.
    (LP: #1952555)
  * debian/patches/0003-Bump-version-to-10.2.patch: Force version string
    to be 0.10.2.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Nov 2021 13:29:56 -0500

flameshot (0.10.2+ds1-1) unstable; urgency=medium

  * New upstream stable release.
  * debian/control: Suggest installation of xdg-desktop-portal packages
    for different desktop environment.
  * debian/control: Bump Standards-Version to 4.6.0.

 -- Boyuan Yang <byang@debian.org>  Sun, 14 Nov 2021 15:57:58 -0500

flameshot (0.10.1+ds1-1) unstable; urgency=medium

  * New upstream stable release.
  * debian/patches: Refresh patches.
  * debian/control: Require spdlog 1.8.5+.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Aug 2021 15:44:59 -0400

=== debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libqt5svg5-dev,
 libsingleapplication-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://flameshot.org
Vcs-Browser: https://salsa.debian.org/debian/flameshot
Vcs-Git: https://salsa.debian.org/debian/flameshot.git

Package: flameshot
Architecture: any
Depends:
 hicolor-icon-theme,
 libqt5svg5,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr,
 grim,
Suggests:
 ca-certificates,
 openssl,
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DFLAMESHOT_ABOUT_DEB_VERSION=$(DEB_VERSION)

=== debian/watch ===
version=4
opts="dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%flameshot-$1.tar.gz%,uversionmangle=s/.rc/~rc/" \
 https://github.com/flameshot-org/flameshot/tags \
 (?:.*?/)?v?(\d[\d.]*r?c?\d?)\.tar\.gz debian uupdate

## flameshot 12.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.13)
 # cmake_policy(SET CMP0076 OLD)
 
-set(FLAMESHOT_VERSION 11.0.0)
+set(FLAMESHOT_VERSION 12.0.0)
 
 # Flameshot-org
 set(GIT_API_URL "https://api.github.com/repos/flameshot-org/flameshot/releases/latest")
@@ -67,6 +67,7 @@
 option(GENERATE_TS "Regenerate translation source files" OFF)
 option(USE_EXTERNAL_SINGLEAPPLICATION "Use external QtSingleApplication library" OFF)
 option(USE_LAUNCHER_ABSOLUTE_PATH "Use absolute path for the desktop launcher" ON)
+option(USE_WAYLAND_CLIPBOARD "USE KF Gui Wayland Clipboard" OFF)
 
 include(cmake/StandardProjectSettings.cmake)
 
@@ -107,6 +108,7 @@
 option(BUILD_STATIC_LIBS ON)
 option(BUILD_SHARED_LIBS OFF)
 add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL) 
+
 
 if (APPLE)
   add_subdirectory(external/QHotkey)

=== debian/changelog ===
flameshot (12.0.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 23 Jun 2022 15:49:48 -0700

flameshot (12.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Jun 2022 12:39:49 -0400

flameshot (12.0~rc1-2) unstable; urgency=medium

  * debian/patches: Add patch to undo broken svg optimization.

 -- Boyuan Yang <byang@debian.org>  Sat, 18 Jun 2022 10:28:31 -0400

flameshot (12.0~rc1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Sat, 18 Jun 2022 10:12:01 -0400

=== debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libqt5svg5-dev,
               libsingleapplication-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://flameshot.org
Vcs-Browser: https://salsa.debian.org/debian/flameshot
Vcs-Git: https://salsa.debian.org/debian/flameshot.git

Package: flameshot
Architecture: any
Depends: hicolor-icon-theme,
         libqt5svg5, 
         ${misc:Depends},
         ${shlibs:Depends},
         grim,
         xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr
Suggests: ca-certificates, openssl
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.

=== debian/rules ===
--- 
+++ 
@@ -22,3 +22,6 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	        -DFLAMESHOT_ABOUT_DEB_VERSION=$(DEB_VERSION)
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## flameshot 12.1.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,10 @@
         Svg
         DBus
         LinguistTools)
+
+if (USE_WAYLAND_CLIPBOARD)
+    find_package(KF5GuiAddons)
+endif()
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
@@ -61,6 +65,10 @@
 
 add_executable(Flameshot::flameshot ALIAS flameshot)
 
+if(FLAMESHOT_ICON)
+  target_compile_definitions(flameshot PUBLIC FLAMESHOT_ICON="${FLAMESHOT_ICON}")
+endif()
+
 if (WIN32)
     set_property(TARGET flameshot PROPERTY WIN32_EXECUTABLE true)
     if (MSVC)
@@ -76,36 +84,42 @@
 add_subdirectory(tools)
 
 
-
-
 set(FLAMESHOT_TS_FILES
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ca.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_cs.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_de_DE.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_el.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_es.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_eu.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_fr.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_hu.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_it_IT.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ja.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ka.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ko.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nb_NO.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl_NL.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pl.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pt_BR.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ru.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sk.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sr_SP.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sv_SE.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_tr.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_uk.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_CN.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_HK.ts
-        ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_TW.ts)
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_bg.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ca.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_cs.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_de_DE.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_el.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_es.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_eu.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_fa.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_fi.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_fr.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_gl.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_grc.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_he.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_hu.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_id.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_it_IT.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ja.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ka.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ko.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nb_NO.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl_NL.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_nl.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pl.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_pt_BR.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_ru.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sk.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sr_SP.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_sv_SE.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_tr.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_uk.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_vi.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_CN.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_HK.ts
+      ${CMAKE_SOURCE_DIR}/data/translations/Internationalization_zh_TW.ts
+         )
 
 if (GENERATE_TS)
     qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${FLAMESHOT_TS_FILES})
@@ -162,6 +176,12 @@
          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/widgets/panel>
          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/widgets/capture>
          $<INSTALL_INTERFACE:include/mylib>)
+target_include_directories(
+    flameshot
+    PUBLIC
+         $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/>
+         )
+
 
 if (USE_EXTERNAL_SINGLEAPPLICATION)
     add_compile_definitions(USE_EXTERNAL_SINGLEAPPLICATION=1)
@@ -182,7 +202,13 @@
         Qt5::Widgets
         ${QTSINGLEAPPLICATION_LIBRARY}
         QtColorWidgets
+
 )
+
+if (USE_WAYLAND_CLIPBOARD)
+  target_compile_definitions(flameshot PRIVATE USE_WAYLAND_CLIPBOARD=1)
+  target_link_libraries(flameshot KF5::GuiAddons)
+endif()
 
 if (APPLE)
     set(MACOSX_BUNDLE_IDENTIFIER "org.flameshot")
@@ -235,25 +261,3 @@
     message("git command is not found")
 endif ()
 target_compile_definitions(flameshot PRIVATE APP_PREFIX="${CMAKE_INSTALL_PREFIX}")
-target_compile_definitions(flameshot PRIVATE APP_VERSION="v${PROJECT_VERSION}")
-target_compile_definitions(flameshot PRIVATE IMGUR_CLIENT_ID="313baf0c7b4d3ff")
-#target_compile_definitions(flameshot PRIVATE QAPPLICATION_CLASS=QApplication)
-target_compile_definitions(flameshot PRIVATE FLAMESHOT_APP_VERSION_URL="${GIT_API_URL}")
-# Enable easier debugging of screenshot capture mode
-if (FLAMESHOT_DEBUG_CAPTURE)
-    target_compile_definitions(flameshot PRIVATE FLAMESHOT_DEBUG_CAPTURE)
-endif ()
-
-if (USE_MONOCHROME_ICON)
-    target_compile_definitions(flameshot PRIVATE USE_MONOCHROME_ICON)
-endif ()
-
-foreach (FILE ${QM_FILES})
-    get_filename_component(F_NAME ${FILE} NAME)
-    add_custom_command(
-            TARGET flameshot
-            POST_BUILD
-            COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/${F_NAME}
-            ${CMAKE_CURRENT_BINARY_DIR}/translations/${F_NAME})
-endforeach ()
-

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 target_sources(flameshot PRIVATE
-    controller.h
+    flameshot.h
     flameshotdaemon.h
     flameshotdbusadapter.h
     qguiappcurrentscreen.h
@@ -7,7 +7,7 @@
 
 target_sources(flameshot PRIVATE
     capturerequest.cpp
-    controller.cpp
+    flameshot.cpp
     flameshotdaemon.cpp
     flameshotdbusadapter.cpp
     qguiappcurrentscreen.cpp

=== src/utils/CMakeLists.txt ===
# Required to generate MOC
target_sources(
  flameshot
  PRIVATE abstractlogger.h
          filenamehandler.h
          screengrabber.h
          systemnotification.h
          valuehandler.h
          request.h
          strfparse.h
)

target_sources(
  flameshot
  PRIVATE abstractlogger.cpp
          filenamehandler.cpp
          screengrabber.cpp
          confighandler.cpp
          systemnotification.cpp
          valuehandler.cpp
          screenshotsaver.cpp
          globalvalues.cpp
          desktopfileparse.cpp
          desktopinfo.cpp
          pathinfo.cpp
          colorutils.cpp
          history.cpp
          strfparse.cpp
        request.cpp
)

=== src/widgets/CMakeLists.txt ===
add_subdirectory(panel)
add_subdirectory(capture)

# Required to generate MOC
target_sources(
        flameshot
        PRIVATE
        infowindow.ui
        capturelauncher.ui
        uploadhistory.ui
        uploadlineitem.ui

        capturelauncher.h
        draggablewidgetmaker.h
        imagelabel.h
        trayicon.h
        infowindow.h
        loadspinner.h
        notificationwidget.h
        orientablepushbutton.h
        uploadhistory.h
        uploadlineitem.h
        updatenotificationwidget.h
        colorpickerwidget.h
        imguploaddialog.h
        capture/capturetoolobjects.h
)

target_sources(
        flameshot
        PRIVATE capturelauncher.cpp
        draggablewidgetmaker.cpp
        imagelabel.cpp
        trayicon.cpp
        infowindow.cpp
        loadspinner.cpp
        notificationwidget.cpp
        orientablepushbutton.cpp
        uploadhistory.cpp
        uploadlineitem.cpp
        updatenotificationwidget.cpp
        colorpickerwidget.cpp
        imguploaddialog.cpp
        capture/capturetoolobjects.cpp
)

=== external/Qt-Color-Widgets/color_widgets_designer_plugin/CMakeLists.txt ===
# Copyright (C) 2013-2020 Mattia Basaglia
#
#
# This software is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with Color Widgets.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.1 FATAL_ERROR)

project(QtColorWidgetsPlugin CXX)


set (CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${CMAKE_SOURCE_DIR}/cmake/modules
  ${CMAKE_CURRENT_LIST_DIR}/..)


include (CheckCXXCompilerFlag)

include (../cmake/versioning.cmake)


SET (${PROJECT_NAME}_VERSION_MAJOR 2)
SET (${PROJECT_NAME}_VERSION_MINOR 2)
SET (${PROJECT_NAME}_VERSION_PATCH 0)
SET (${PROJECT_NAME}_VERSION "${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}.${${PROJECT_NAME}_VERSION_PATCH}")


find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Designer REQUIRED)

# Auto generate moc files
set(CMAKE_AUTOMOC ON)
# Auto generate moc files
set(CMAKE_AUTOUIC ON)
# Auto generate moc files
set(CMAKE_AUTORCC ON)

check_cxx_compiler_flag ("-Wall" Wall_FLAG_SUPPORTED)

if (Wall_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
endif (Wall_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-pedantic" pedantic_FLAG_SUPPORTED)

if (pedantic_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pedantic")
endif (pedantic_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-Wextra" Wextra_FLAG_SUPPORTED)

if (Wextra_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wextra")
endif (Wextra_FLAG_SUPPORTED)

# Library
set (TARGET_NAME ${PROJECT_NAME})
set (TARGET_OUTPUT_SUFFIX "-Qt${QT_VERSION}${${PROJECT_NAME}_VERSION_MAJOR}")

add_library (${TARGET_NAME} SHARED "")
set_target_properties(${TARGET_NAME}
  PROPERTIES
  EXPORT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")

set_target_properties (${TARGET_NAME}
  PROPERTIES
  CXX_STANDARD 11
  CXX_STANDARD_REQUIRED ON
  VERSION ${${PROJECT_NAME}_VERSION}
  SOVERSION ${${PROJECT_NAME}_VERSION_MAJOR}
  "INTERFACE_${PROJECT_NAME}_MAJOR_VERSION" ${${PROJECT_NAME}_VERSION_MAJOR}
  COMPATIBLE_INTERFACE_STRING "${PROJECT_NAME}_MAJOR_VERSION"
  OUTPUT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")


target_link_libraries(${TARGET_NAME}
  PRIVATE
  ${COLOR_WIDGETS_LIBRARY}
  Qt${QT_VERSION_MAJOR}::Designer
  )


# Sources
set(SOURCES
  color_preview_plugin.cpp
  color_wheel_plugin.cpp
  color_widget_plugin_collection.cpp
  gradient_slider_plugin.cpp
  hue_slider_plugin.cpp
  color_selector_plugin.cpp
  color_list_plugin.cpp
  swatch_plugin.cpp
  color_palette_widget_plugin.cpp
  color_2d_slider_plugin.cpp
  color_line_edit_plugin.cpp
  gradient_editor_plugin.cpp
  # add new sources above this line
  )

foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

set(HEADERS
  color_preview_plugin.hpp
  color_wheel_plugin.hpp
  color_widget_plugin_collection.hpp
  gradient_slider_plugin.hpp
  hue_slider_plugin.hpp
  color_selector_plugin.hpp
  color_list_plugin.hpp
  swatch_plugin.hpp
  color_palette_widget_plugin.hpp
  color_2d_slider_plugin.hpp
  color_line_edit_plugin.hpp
  gradient_editor_plugin.hpp
  # add new headers above this line
  )

foreach (HEADER IN LISTS HEADERS)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${HEADER}>)
endforeach (HEADER IN HEADERS)


# install
get_target_property (QT_QMAKE_EXECUTABLE
  Qt${QT_VERSION_MAJOR}::qmake LOCATION)

execute_process (
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_INSTALL_PLUGINS
  OUTPUT_STRIP_TRAILING_WHITESPACE)

# install(TARGETS ${COLOR_WIDGETS_PLUGIN} DESTINATION ${QT_INSTALL_PLUGINS}/designer OPTIONAL)

execute_process (
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_LIBS
  OUTPUT_VARIABLE QT_INSTALL_LIBS
  OUTPUT_STRIP_TRAILING_WHITESPACE)

# install(TARGETS ${COLOR_WIDGETS_PLUGIN} DESTINATION ${QT_INSTALL_LIBS}/qtcreator/plugins OPTIONAL)

add_custom_target(${TARGET_NAME}_install
    COMMAND cp $<TARGET_FILE:${TARGET_NAME}> ${QT_INSTALL_PLUGINS}/designer
    COMMAND cp $<TARGET_FILE:${TARGET_NAME}> ${QT_INSTALL_LIBS}/qtcreator/plugins
    DEPENDS ${TARGET_NAME}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== external/singleapplication/examples/basic/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)

project(basic LANGUAGES CXX)

# SingleApplication base class
set(QAPPLICATION_CLASS QCoreApplication)

add_executable(basic main.cpp)

find_package(Qt5 COMPONENTS Core REQUIRED)
add_subdirectory(../.. SingleApplication)
target_link_libraries(${PROJECT_NAME} SingleApplication::SingleApplication)

=== debian/changelog ===
flameshot (12.1.0-2) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.6.2.
  * debian/rules: Disable using absolute path for launcher and
    desktop file. (Closes: #1026888)

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Feb 2023 16:36:04 -0500

flameshot (12.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 05 Jul 2022 15:27:48 -0400

=== debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libqt5svg5-dev,
 libsingleapplication-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://flameshot.org
Vcs-Browser: https://salsa.debian.org/debian/flameshot
Vcs-Git: https://salsa.debian.org/debian/flameshot.git

Package: flameshot
Architecture: any
Depends:
 hicolor-icon-theme,
 libqt5svg5,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr,
 grim,
Suggests:
 ca-certificates,
 openssl,
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	        -DFLAMESHOT_ABOUT_DEB_VERSION=$(DEB_VERSION)
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+	        -DFLAMESHOT_ABOUT_DEB_VERSION=$(DEB_VERSION) \
+		-DUSE_LAUNCHER_ABSOLUTE_PATH:BOOL=OFF \
+		$(NULL)
